.486p
.model huge

stapel segment use16 stack 'stack'
           dw 1000h dup(0)
stapel ends

code segment use16 'code'
assume cs:code,ds:code,ss:stapel

start:
           mov ax,13h               ; VGA - 320 x 200 x 256 col
           int 10h
           mov al,0d1h
           out 64h,al               ; Gate A20 freischalten
           mov cx,5000
   wait1:  loop wait1
           mov al,0dfh
           out 60h,al
           mov cx,5000
   wait2:  loop wait2

;Loading
           mov ax,cs
           mov ds,ax
           mov dx,offset Load     ;Name der Datei
           mov ah,3dh
           mov al,0                 ;nur lesen
           int 21h                  ;Datei ffnen
           mov bx,ax
           push bx                  ;Handle sichern
           mov cx,64768             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen
           pop bx                   ;Handle zurck
           mov ah,3eh
           int 21h                  ;Datei schlieen

           mov ax,06000h
           mov ds,ax
           xor cl,cl
           xor si,si
Set_Pal1:
           mov al,cl
           mov dx,3c8h
           out dx,al
           mov dx,3c9h
           mov al,[si+64000]
           out dx,al
           inc si
           mov al,[si+64000]
           out dx,al
           inc si
           mov al,[si+64000]
           out dx,al
           inc si
           inc cl
           jnz Set_Pal1

           call Init_PM
           mov cx,64000
           xor edi,edi
     Pcopy:mov al,FS:[60000h+edi]
           mov FS:[0A0000h+edi],al
           inc edi
           loop Pcopy
           call Init_RM

;Load Spr1
           mov ax,cs
           mov ds,ax
           mov dx,offset SPName     ;Name der Datei
           mov ah,3dh
           mov al,0                 ;nur lesen
           int 21h                  ;Datei ffnen
           mov bx,ax
           push bx                  ;Handle sichern
           mov cx,65535             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen

           call Init_PM
           mov ax,10h
           mov FS,ax
           xor edi,edi
Spr_Cpy:   mov al,FS:[060000h+edi]
           mov FS:[150000h+edi],al  ;Sprite nach 150000h
           inc di
           jnz  Spr_Cpy
           mov ax,60h
           mov ds,ax
           mov si,offset S01_Des
           xor ebp,ebp
           xor edi,edi
           xor cx,cx
           xor ebx,ebx
SpDesSet:  mov bx,fs:[150000h+edi]
           mov ds:[si+2],bx
           add esi,8
           inc di
           inc di
           inc cl
           cmp cl,FS:[1500FEh]
           jne SpDesSet
           call Init_RM

           pop bx
           push bx
           mov cx,65535             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen

           call Init_PM
           mov ax,10h
           mov FS,ax
           xor edi,edi
Spr_Cpyx:  mov al,FS:[060000h+edi]
           mov FS:[160000h+edi],al  ;Sprite nach 160000h
           inc di
           jnz  Spr_Cpyx
           mov ax,FS:[1500FEh]
           shl ax,3
           mov bx,60h
           mov ds,bx
           xor esi,esi
           mov si,offset S01_Des
           add si,ax
           xor ebp,ebp
           xor edi,edi
           xor cx,cx
           mov eax,93160000h
SpDesSet2: mov ax,fs:[160000h+edi]
           mov ds:[si+2],eax
           add esi,8
           add bp,8
           inc di
           inc di
           inc cl
           cmp cl,FS:[1600FEh]
           jne SpDesSet2
           call Init_RM

           pop bx                   ;Handle
           push bx
           mov cx,65535             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen

           pop bx                   ;Handle zurck
           mov ah,3eh
           int 21h                  ;Datei schlieen

           call Init_PM
           mov ax,10h
           mov FS,ax
           xor edi,edi
SprCpyy:   mov al,FS:[060000h+edi]
           mov FS:[170000h+edi],al  ;Sprite nach 170000h
           inc di
           jnz  SprCpyy
           mov ax,FS:[1500FEh]
           add ax,FS:[1600FEh]
           shl ax,3
           mov bx,60h
           mov ds,bx
           xor esi,esi
           mov si,offset S01_Des
           add si,ax
           xor ebp,ebp
           xor edi,edi
           xor cx,cx
           mov eax,93170000h
SpDesSet3: mov ax,fs:[170000h+edi]
           mov ds:[si+2],eax
           add esi,8
           add bp,8
           inc di
           inc di
           inc cl
           cmp cl,FS:[1700FEh]
           jne SpDesSet3

           mov dx,3                   ; Power of Enemy
           mov FS:[11F80Ah],dx
           mov ax,22       ;40        ;Sprite Nummer
           mov FS:[11F808h],ax
           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,5                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx

           call Init_RM

;Load Sprite Moving Tabs

           mov ax,cs
           mov ds,ax
           mov dx,offset S_Tab      ;Name der Datei
           mov ah,3dh
           mov al,0                 ;nur lesen
           int 21h                  ;Datei ffnen
           mov bx,ax
           push bx                  ;Handle sichern
           mov cx,4000h             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen
           pop bx                   ;Handle zurck
           mov ah,3eh
           int 21h                  ;Datei schlieen

           call Init_PM
           xor edi,edi
STabCpy:   mov al,FS:[060000h+edi]
           mov FS:[1F0000h+edi],al  ;Sprite-Moving-Tabs nach 1F0000h
           inc di
           jnz STabCpy
           xor ax,ax
           mov gs:[2020],ax
           mov gs:[2028],al
           mov FS:[11F80Ch],ax
           mov FS:[11F806h],ax
           mov FS:[11F804h],ax
           mov FS:[11F810h],ax
           mov FS:[11F812h],ax
           mov FS:[11F814h],ax
           mov FS:[11F818h],ax
           mov FS:[11F81Ah],ax  ;Punkte
           mov FS:[11F81Ch],ax
           mov FS:[11F81Eh],ax
           mov ah,1             ;Lives
           mov al,5
           mov FS:[11F84Eh],ax    ;0e
           xor eax,eax
           mov FS:[11F820h],eax   ; x , y , Shoot E/A , 1 ;s1
           mov FS:[11F824h],eax
           mov FS:[11F828h],eax   ; Double-Shoot          ;s2
           mov FS:[11F82Ch],eax
           mov FS:[11F830h],eax                           ;s3
           mov FS:[11F834h],eax
           mov FS:[11F838h],eax                           ;s4
           mov FS:[11F83Ch],eax
           mov FS:[11F840h],ax
           mov FS:[11F844h],al
           mov FS:[11F83Eh],al
           mov FS:[11F826h],al
           mov FS:[11F816h],ax

                                ;Sound Start
           mov eax,200000h
           mov FS:[11F847h],eax
           mov GS:[2000],eax
           call Init_RM

;Load Sprite Kollision Tabs

           mov ax,cs
           mov ds,ax
           mov dx,offset Kollision  ;Name der Datei
           mov ah,3dh
           mov al,0                 ;nur lesen
           int 21h                  ;Datei ffnen
           mov bx,ax
           push bx                  ;Handle sichern
           mov cx,1000h             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen
           pop bx                   ;Handle zurck
           mov ah,3eh
           int 21h                  ;Datei schlieen

           call Init_PM
           mov ax,10h
           mov FS,ax
           xor edi,edi
           mov cx,4000h
STabCpyy:  mov al,FS:[060000h+edi]
           mov FS:[1EC000h+edi],al  ;Sprite-Moving-Tabs nach 1EC000h
           inc di
           loop STabCpyy
           call Init_RM

;Load Sound

           mov ax,cs
           mov ds,ax
           mov dx,offset WAV        ;Name der Datei
           mov ah,3dh
           mov al,0                 ;nur lesen
           int 21h                  ;Datei ffnen
           mov bx,ax
           push bx                  ;Handle sichern
           mov cx,8000              ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen

           xor ax,ax
           push ax
SL:
           pop ax
           pop bx
           push bx
           push ax
           mov cx,65535             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen

           call Init_PM
           mov ax,10h
           mov FS,ax
           mov edi,FS:[11F847h]
           xor esi,esi
           mov cx,65535
SLCpy:     mov al,FS:[60000h+esi]
           mov FS:[edi],al           ;Sound nach 200000h
           inc edi
           inc esi
           loop SLCpy
           mov FS:[11F847h],edi
           call Init_RM

           pop ax
           inc ax
           push ax
           cmp ax,32
           jne SL

           pop ax
           pop bx                   ;Handle zurck
           mov ah,3eh
           int 21h                  ;Datei schlieen

;Load Tab
           mov ax,cs
           mov ds,ax
           mov dx,offset T_Name     ;Name der Datei
           mov ah,3dh
           mov al,0                 ;nur lesen
           int 21h                  ;Datei ffnen
           mov bx,ax
           push bx                  ;Handle sichern
           mov cx,1900h             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,06000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen
           pop bx                   ;Handle zurck
           mov ah,3eh
           int 21h                  ;Datei schlieen

           call Init_PM

           mov ax,10h
           mov FS,ax
           xor edi,edi
           mov di,1900h
T02Cpy:    mov al,FS:[060000h+edi]  ;Tab nach 1480000h
           mov FS:[148000h+edi],al
           dec di
           cmp di,65535
           jne  T02Cpy
           call Init_RM

;Load Pic
           mov ax,cs
           mov ds,ax
           mov dx,offset D_Name     ;Name der Datei
           mov ah,3dh
           mov al,0                 ;nur lesen
           int 21h                  ;Datei ffnen
           mov bx,ax
           push bx                  ;Handle sichern
           mov cx,64768             ;Anz. der Bytes
           xor dx,dx                ;Offset  Addr.
           mov ax,6000h            ;Segment Addr.
           mov ds,ax
           mov ah,3fh
           int 21h                  ;Datei lesen
           pop bx                   ;Handle zurck
           mov ah,3eh
           int 21h                  ;Datei schlieen

           mov ax,6000h
           mov ds,ax
           xor cl,cl
           xor si,si
Set_Pal:
           mov al,cl
           mov dx,3c8h
           out dx,al

           mov dx,3c9h

           mov al,[si+64000]
           out dx,al
           inc si
           mov al,[si+64000]
           out dx,al
           inc si
           mov al,[si+64000]
           out dx,al
           inc si
           inc cl
           jnz Set_Pal

           cli
           xor di,di
SBInit:
           mov dx,216h
           add dx,di
           mov al,1
           out dx,al

           mov cx,65535
Wtew:      nop
           nop
           nop
           loop Wtew

           xor al,al
           out dx,al

           mov cx,65535
Wtew2:     nop
           nop
           nop
           loop Wtew2

           mov dx,21Ah
           add dx,di
           in  al,dx
           cmp al,170
           jne NoSndx     ;No Soundblaster found

           mov al,255-1-2-4
           out 21h,al
           mov al,1
           mov si,offset Keys
           mov cs:[2020+si],al
           mov cs:[2021+si],al

           mov dx,21Eh
           add dx,di
           mov si,offset SBPort2
           inc si
           mov cs:[si],dl
           mov dx,21Ch
           add dx,di
           mov si,offset SBPort1
           inc si
           mov cs:[si],dl

           mov al,0D1h    ;Speaker On
           out dx,al

           mov al,1        ;SB-detected
           mov si,offset keys
           mov cs:[2020+si],al
           mov cs:[2021+si],al

           mov dx,21Ch
           add dx,di
           mov al,40h
           out dx,al      ;DSP-Command
SBWaitxx1: in al,dx
           and al,128
           jnz SBWaitxx1
           mov al,166     ;Sample-Rate
           out dx,al

           mov al,4
           out 8,al       ;DMA 1 u.2 gesperrt
           out 0d0h,al
           mov al,80
           out 21h,al     ;alle IRQ's frei
           xor al,al
           out 10,al
           out 15,al      ;Kanle frei
           out 12,al

           xor dx,dx      ;Set Counters
           mov al,255
      Prt1:out dx,al
           out dx,al
           inc dx
           cmp dx,8
           jne Prt1

           mov dx,192
      Prt2:out dx,al
           out dx,al
           inc dx
           inc dx
           cmp dx,208
           jne Prt2

           xor al,al
           out 0d4h,al
           out 0deh,al
           out 12,al      ;Flip Flop clear
           out 0d8h,al
           mov al,1+8+64  ;Mode
           out 11,al
           out 0d6h,al

           xor al,al
           out 8,al       ;DMA 1 u.2 frei
           out 0d0h,al

           mov dx,21ch
           add dx,di
           mov al,14h
           out dx,al
SBWaitxz2: in al,dx
           and al,128
           jnz SBWaitxz2
           mov al,1
           out dx,al       ;Play 1 Byte
SBWaitxz3: in al,dx
           and al,128
           jnz SBWaitxz3
           mov al,0
           out dx,al

           mov eax,12000000
Scan:      nop
           nop
           nop
           dec eax
           jnz Scan
           cli
           xor al,al
           out 21h,al
           mov al,4
           out 8,al
           out 0d0h,al

           xor cx,cx
           xor bp,bp

           mov dx,1
    Chan1: in al,dx
           mov ah,al
           in al,dx
           cmp ah,255
           je Nch1
           mov bp,cx    ;DMA 1
      Nch1:inc cx
           inc dx
           inc dx
           cmp dx,9
           jne Chan1

           mov dx,193
    Chan2: in al,dx
           mov ah,al
           in al,dx
           cmp ah,255   ;DMA 2
           je Nch2
           mov bp,cx
      Nch2:inc cx                    ;   HHHHH   H    H    HHH
           add dx,4                  ;    H   H  HH  HH   H   H
           cmp dx,209                ;    H   H  H HH H  H*****H
           jne Chan2                 ;    H   H  H    H  H     H
                                     ;   HHHHH   H    H  H     H
           and bp,7                  ;
           mov dl,87h                ;
           cmp bp,1                  ;
           jne Nchan1                ;      Auto Detection
           mov dl,83h
    Nchan1:cmp bp,2
           jne Nchan2
           mov dl,81h
    Nchan2:cmp bp,3
           jne Nchan3  ;Page Regs
           mov dl,82h
    Nchan3:cmp bp,4
           jne Nchan4
           mov dl,8Fh
    Nchan4:cmp bp,5
           jne Nchan5
           mov dl,8Bh
    Nchan5:cmp bp,6
           jne Nchan6
           mov dl,89h
    Nchan6:cmp bp,7
           jne Nchan7
           mov dl,8Ah
    Nchan7:

           mov si,offset DMAPage
           inc si
           mov cs:[si],dl

           mov dl,13
           and bp,4
           jz  xNoChange
           mov dl,0dah
 xNoChange:
           mov si,offset DMATemp1
           inc si
           mov cs:[si],dl
           mov si,offset DMATemp2
           inc si
           mov cs:[si],dl

           mov al,255
           out 161,al
           mov al,255-1-2-4
           out 21h,al

           mov al,4
           out 8,al
           out 0d0h,al

           mov al,255
           out 10,al
           out 0d4h,al
           out 15,al
           out 0deh,al

           mov dx,216h
           add dx,di
           mov al,1
           out dx,al
           mov cx,65535
mtewxy:    nop
           nop           ;DSP-Reset
           nop
           loop mtewxy
           xor al,al
           out dx,al

           mov si,offset keys
           mov cs:[2030+si],di

           mov eax,200000
Scan2:     nop
           nop
           nop
           dec eax
           jnz Scan2

           call Init_PM
           xor al,al
           out 21h,al
           sti

           mov di,gs:[2030]

           mov dx,216h
           add dx,di
           mov al,1
           mov gs:[2028],al
           out dx,al
           mov cx,65535
mtew:      nop
           nop           ;DSP-Reset
           nop
           loop mtew
           xor al,al
           out dx,al
           mov dx,21ch
           add dx,di
           mov al,0d1h
           out dx,al

           mov cx,65535
xtew:      nop
           nop
           nop
           loop xtew

           mov dx,21Ch
           add dx,di
           mov al,40h
           out dx,al      ;DSP-Command
SBWaitzz1: in al,dx
           and al,128
           jnz SBWaitzz1
           mov al,166     ;Sample-Rate
           out dx,al

           mov al,4
           out 8,al       ;DMA 1 u.2 gesperrt
           out 0d0h,al

           mov dx,81h
           mov al,20h
  StPge:   out dx,al
           inc dx
           cmp dx,90h
           jne StPge

           xor al,al
           out 0,al
           out 0,al
           out 2,al
           out 2,al
           out 4,al
           out 4,al    ;Start Adress
           out 6,al
           out 6,al
           out 192,al
           out 192,al
           out 196,al
           out 196,al
           out 200,al
           out 200,al
           out 204,al
           out 204,al
           out 21h,al     ;alle IRQ's frei
           out 10,al
           out 15,al      ;Kanle frei
           out 0d4h,al
           out 0deh,al
           out 12,al      ;Flip Flop clear
           out 0d8h,al
           out 8,al       ;DMA 1 u.2 frei
           out 0d0h,al

           mov al,255         ;Set Counters
           mov dx,193
     xPrt2:out dx,al
           out dx,al
           add dx,4
           cmp dx,209
           jne xPrt2

           mov al,255
           out 1,al
           out 1,al
           out 3,al
           out 3,al
           out 5,al
           out 5,al
           out 7,al
           out 7,al

           mov al,1+8+16+64  ;Mode Reg
           out 11,al         ;Auto Init On
           out 0d6h,al

           mov dx,21ch
           add dx,di
           mov al,14h
           out dx,al
SBWaitxx2: in al,dx
           and al,128
           jnz SBWaitxx2
           mov al,255
           out dx,al
SBWaitxx3: in al,dx
           and al,128
           jnz SBWaitxx3
           mov al,255
           out dx,al
           jmp SoundPlay

 NoSndx:
           add di,10h
           cmp di,70h
           jne SBInit

           call Init_PM
           sti
SoundPlay:
           mov cx,64000
           xor edi,edi
    Pcopy1:mov al,FS:[60000h+edi]
           mov FS:[0A0000h+edi],al
           inc edi
           loop Pcopy1

           mov al,1
           mov gs:[622],al

           xor ebx,ebx
           xor ebp,ebp
           mov dx,168
           mov esi,0A0000h
           mov edi,0100000h
CopyY:
           mov cx,320
CopyX:
           mov al,[esi+ebx]
           mov [edi+ebp],al
           mov [edi+ebp+320],al
           inc ebx
           inc ebp
           loop CopyX

           add ebp,320

           dec dx
           jnz CopyY
           cld
           mov ecx,400
           xor ax,ax
           mov edi,11F400h
Kill:      mov FS:[edi],al        ; Kill Scr.Tab
           inc di
           loop Kill
           mov edi,11FFFDh
           mov FS:[edi],ax
Esc_Key:
           mov ax,FS:[11F818h]
           cmp ax,0
           jz  NGO
   WEsc:   mov al,gs:[1]
           rol al,1
           jc  Wesc
           jmp Ende
   NGO:
           mov ax,28h
           mov ds,ax
           mov ax,38h             ; Set Sel.
           mov es,ax

           xor ebp,ebp
           xor edx,edx
           xor eax,eax
           xor esi,esi
           xor edi,edi
           xor bx,bx
Y_Pos:
           mov bp,ax
           shl bp,1

           mov si,bx
           shl si,1
           add si,FS:[ebp+11F400h]
           mov di,dx
           call Move
           add dx,512
           add bx,320
           inc ax
           cmp ax,100
           jne  Y_Pos
           cld
           clc
           mov ax,30h
           mov ds,ax            ; Set Sel.
           mov ax,40h
           mov es,ax
           mov ax,100
           xor edi,edi
           xor esi,esi
           xor ebp,ebp
           xor bx,bx
           xor dx,dx
Y_Pos2:
           mov bp,ax
           shl bp,1

           mov si,bx
           shl si,1
           add si,FS:[ebp+11F400h]
           mov di,dx
           call Move
           add dx,512
           add bx,320
           inc ax
           cmp ax,168
           jne  Y_Pos2

    mov ax,10h
    mov ds,ax
    xor ebx,ebx
    mov al,[ebx+11FFFFh]
    mov dl,al
    inc al                         ;Zhler
    not dl
    xor dl,al
    mov [ebx+11FFFFh],al
    mov dh,dl
    xor edi,edi

           mov cx,16
           mov di,0
           call Scr                         ; Ebene 1

    mov dl,dh
    and dl,4
    jz  e2
           mov cx,13
           mov di,32
           call Scr                         ; Ebene 2
    e2:
    mov dl,dh
    and dl,2
    jz  e3
           mov cx,13
           mov di,58
           call Scr                         ; Ebene 3
           mov cx,fs:[11F800h]
           dec cx             ; Tree Count
           mov fs:[11F800h],cx
    e3:
    mov dl,dh
    and dl,4
    jnz  e4
           mov cx,9
           mov di,84
           call Scr                         ; Ebene 4
    e4:
    mov dl,dh
    and dl,8
    jnz  e5
           mov cx,7
           mov di,102
           call Scr                         ; Ebene 5
    e5:
    mov dl,dh
    and dl,16
    jnz  e6
           mov cx,5
           mov di,116
           call Scr                         ; Ebene 6
    e6:
    mov dl,dh
    and dl,4
    jnz  e7
           mov cx,21
           mov di,126
           call Scr                         ; Ebene 7
    e7:
    mov dl,dh
    and dl,2
    jnz  e8
           mov cx,46
           mov di,168
           call Scr                         ; Ebene 8
    e8:
    mov dl,dh
    and dl,4
    jz  e10
           mov cx,14
           mov di,308
           call Scr                         ; Ebene 10
    e10:

           xor ebx,ebx
           mov dl,[11FFFCh+ebx]
           inc dl
           mov [11FFFCh+ebx],dl
           mov ax,[11FFFDh+ebx]
           inc ax
           cmp ax,639
           jng WT2
           and ax,2ffh                         ; Scroll Ebene
           sub ax,640
WT2:       mov [11FFFDh+ebx],ax
           shr ax,1
           mov cx,24                           ; Ebene 9
           mov di,260
           mov bl,dl
           shl bl,3
           xor bh,bh
Scr2:      add bl,25
           xor dx,dx
           mov dl,[148000h+ebx]
           add dx,ax
           cmp dx,319
           jng WT3
           sub dx,320
WT3:       mov [11F400h+edi],dx
           inc di
           inc di
           inc bh
           loop Scr2

   ;------------------------------

   clc

   mov al,gs:[2021]
   cmp al,0
   je  NF
   mov al,gs:[59]
   rol al,1
   jc NF1
   xor al,al
   mov gs:[2020],al
   mov gs:[2028],al
   mov al,4
   out 8,al        ;Sound Off
   out 0d0h,al
NF1:
   mov al,gs:[60]
   rol al,1
   jc NF2
   mov al,1
   mov gs:[2020],al
   mov gs:[2028],al
   mov al,0
   out 8,al        ;Sound On
   out 0d0h,al
NF2:
   mov al,gs:[61]
   rol al,1
   jc NF3                    ;Equalizer Off
   xor al,al
   mov gs:[2020],al
NF3:
   mov al,gs:[62]
   rol al,1
   jc NF                      ;Equalizer ON
   mov al,gs:[2028]
   cmp al,0
   jz NF
   mov al,1
   mov gs:[2020],al
NF:

   mov al,gs:[28]
   rol al,1
   jc  Cheat
   mov al,gs:[15]
   rol al,1
   jc  Cheat
   mov al,gs:[81]
   rol al,1
   jc  Cheat
   mov ax,6
   mov FS:[11F826h],ax
   mov FS:[11F82Eh],ax
   mov gs:[144],ax
   mov ax,3
   mov FS:[11F836h],ax
   mov FS:[11F83Eh],ax
   mov al,1
   mov ah,1
   mov FS:[11F840h],ax
   mov FS:[11F812h],al
   mov FS:[11F844h],al
   mov ax,3000
   mov FS:[11F845h],ax
   Cheat:
    ;-----------------------------------


           mov ax,60h
           mov ds,ax
           mov eax,93124060h             ; 1st Number
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F84Fh]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124070h             ; 2nd Number
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F84Eh]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+320-16             ; 1.Stelle
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F81Ah]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+320-32             ; 2.Stelle
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F81Bh]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+320-48             ; 3.Stelle
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F81Ch]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+320-64             ; 4.Stelle
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F81Dh]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+320-80             ; 5.Stelle
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F81Eh]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+320-96             ; 6.Stelle
           mov di,offset CHG_Des
           mov [di+2],eax
           mov al,FS:[11F81Fh]
           and al,15
           xor ah,ah
           shl ax,3
           add ax,140h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   ;-------------------------------

   mov al,gs:[29]
   rol al,1
   jc  Nst
   mov ax,1
   mov FS:[11F814h],ax
   Nst:
      mov ax,FS:[11F814h]
      cmp ax,0
      jnz AllSprites
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+512*100+90             ; Get Ready
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,198h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
    jmp NoSprites
   ;-------------------------------
AllSprites:                 ;69=Pause - 29 = Fire
           mov al,gs:[69]
           rol al,1
           jc  Pause
           xor cx,cx
      PSE: loop PSE
      PSE2:loop PSE2
      PSE3:loop PSE3
   UntilF: mov al,gs:[29]
           rol al,1
           jc UntilF
   Pause:
           xor eax,eax
           mov ax,FS:[11F810h]
           dec ax
           mov FS:[11F810h],ax
           mov bx,ax
           and bx,1536
           jnz Nost
           and ax,511
           mov bx,60h
           mov ds,bx
           add eax,931241A0h+40*512        ; Station
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,1A0h       ;258h  ;1A0h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   NoSt:
   ;-------------------------------
           xor eax,eax
           mov ax,FS:[11F810h]
           add ax,768
           mov bx,ax
           and bx,1536
           jnz Nost3
           and ax,511
           mov bx,60h
           mov ds,bx

           xor ebx,ebx
           mov bx,FS:[11F810h]
           and bx,511
           mov cx,260h       ;260h  ;2F0h

           add eax,931241A0h+40*512        ; Station 2
           mov di,offset CHG_Des
           mov [di+2],eax

           mov ds,cx
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
   NoSt3:
;-------------------------------------
           mov ax,FS:[11F816h]
           cmp ax,0
           jz  AllEnemys
           cmp ax,19
           jg  NExplode

           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,gs:[132]
           sub bx,20
           shl ebx,9
           xor eax,eax
           mov ax,gs:[130]         ;Ship
           sub ax,30
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,FS:[11F816h]  ;Explosion
           shr ax,2
           inc ax
           shl ax,3
           add ax,0B8h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
           mov ax,FS:[11F816h]
           inc ax
           mov FS:[11F816h],ax
           jmp NoEnemys
NExplode:  cmp ax,100
           je  Clr
           mov ax,FS:[11F816h]
           inc ax
           mov FS:[11F816h],ax
           jmp NoEnemys
    Clr:   mov al,FS:[11F84Eh]
           dec al
           mov FS:[11F84Eh],al
           cmp al,255
           jne NotEqual5
           mov al,9
           mov FS:[11F84Eh],al
           mov al,FS:[11F84Fh]
           dec al
           mov FS:[11F84Fh],al
           cmp al,255
           jne NotEqual5
           mov al,9
           mov FS:[11F84Fh],al

           mov ax,60h
           mov ds,ax
           mov eax,93124060h+512*100+90             ; GAME OVER
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,190h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
           mov ax,1
           mov FS:[11F818h],ax
           jmp NoSprites
NotEqual5:
           mov ax,242
           mov gs:[130],ax
           mov ax,122
           mov gs:[132],ax      ;Loose a Life
           xor ax,ax
           mov FS:[11F816h],ax
           mov FS:[11F806h],ax
           mov FS:[11F804h],ax
           mov FS:[11F812h],ax
           mov FS:[11F824h],ax
           mov FS:[11F82Ch],ax
           mov FS:[11F834h],ax  ;Sat +2*Shoot
           mov FS:[11F83Ch],ax
           mov FS:[11F840h],ax
           mov FS:[11F844h],al
           mov gs:[128],al

           mov al,FS:[11F83Eh]
           cmp al,0
           je  Ndec1
           dec al
           mov FS:[11F83Eh],al
           mov FS:[11F836h],al
           jmp EndDec
     Ndec1:
           mov al,FS:[11F82Eh]
           cmp al,0
           jz  Ndec2
           dec al
           dec al
           mov FS:[11F82Eh],al
           mov FS:[11F826h],al
           jmp EndDec
     Ndec2:
           mov al,GS:[144]
           cmp al,1
           je  EndDec
           dec al
           mov GS:[144],al
    EndDec:xor di,di
           xor ax,ax
     Rst:  mov gs:[146+di],al
           inc di
           cmp di,1000
           jne Rst

;--------------------------------------------

AllEnemys:
           mov al,gs:[128]
           ror al,1
           jnc No_Shoot
           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bl,gs:[140]
           xor bh,bh
           shl ebx,9                         ; Shoot
           xor ecx,ecx
           mov cx,gs:[138]
           mov eax,ecx
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,gs:[144]       ; Shoot
           shl ax,3
           add ax,70h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4

           mov ax,gs:[138]
           add ax,15        ; Speed  1
           mov gs:[138],ax
           cmp ax,511
           jng No_Shoot
           xor al,al
           mov gs:[128],al
No_Shoot:
;--------------------------------

           mov al,FS:[11F826h]
           cmp al,0
           jz  NoShoot31

           mov al,FS:[11F824h]
           ror al,1
           jnc No_Shoot3
           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,FS:[11F822h]
           xor bh,bh
           shl ebx,9              ; Shoot2
           xor ecx,ecx
           mov cx,FS:[11F820h]
           mov eax,ecx
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,FS:[11F826h]   ; Shoot
           shl ax,3
           add ax,1E0h
           mov bx,gs:[129]
           and bx,8
           sub ax,bx
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4

           mov ax,FS:[11F820h]
           add ax,3           ; Speed  2 x
           mov FS:[11F820h],ax
           cmp ax,511
           jb  No_Shoot2
           xor ax,ax
           mov FS:[11F824h],al
No_Shoot2:
           mov ax,FS:[11F822h]
           add ax,3            ; Speed  2 y
           mov FS:[11F822h],ax
           cmp ax,200
           jb  No_Shoot3
           xor ax,ax
           mov FS:[11F824h],al
No_Shoot3:
;-------------------------------
           mov al,FS:[11F82Ch]
           ror al,1
           jnc NoShoot31
           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,FS:[11F82Ah]
           xor bh,bh
           shl ebx,9              ; Shoot 3
           xor ecx,ecx
           mov cx,FS:[11F828h]
           mov eax,ecx
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,FS:[11F82Eh]   ; Shoot 3
           shl ax,3
           add ax,1B0h
           mov bx,gs:[129]
           and bx,8
           sub ax,bx
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
           mov ax,FS:[11F828h]
           add ax,3           ; Speed  3 x
           mov FS:[11F828h],ax
           cmp ax,511
           jb  NoShoot21
           xor ax,ax
           mov FS:[11F82Ch],ax
 NoShoot21:
           mov ax,FS:[11F82Ah]
           xor ah,ah
           sub ax,3            ; Speed  3 y
           mov FS:[11F82Ah],ax
           cmp ax,0
           jg  NoShoot31
           xor ax,ax
           mov FS:[11F82Ch],ax
NoShoot31:
;----------------------------------

           mov al,FS:[11F836h]
           cmp al,0
           jz  NoShoot312

           mov al,FS:[11F834h]
           ror al,1
           jnc No_Shoot32
           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,FS:[11F832h]
           xor bh,bh
           shl ebx,9              ; Shoot4
           xor ecx,ecx
           mov cx,FS:[11F830h]
           mov eax,ecx
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,FS:[11F836h]   ; Shoot
           shl ax,3
           add ax,220h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4

           mov ax,FS:[11F832h]
           add ax,8            ; Speed  4 y
           mov FS:[11F832h],ax
           cmp ax,200
           jb  No_Shoot32
           xor ax,ax
           mov FS:[11F834h],al
No_Shoot32:
;-------------------------------
           mov al,FS:[11F83Ch]
           ror al,1
           jnc NoShoot312
           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,FS:[11F83Ah]
           xor bh,bh
           shl ebx,9              ; Shoot 5
           xor ecx,ecx
           mov cx,FS:[11F838h]
           mov eax,ecx
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,FS:[11F83Eh]   ; Shoot 5
           shl ax,3
           add ax,220h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
           mov ax,FS:[11F83Ah]
           xor ah,ah
           sub ax,8            ; Speed  5 y
           mov FS:[11F83Ah],ax
           cmp ax,0
           jg  NoShoot312
           xor ax,ax
           mov FS:[11F83Ch],ax
NoShoot312:
;-------------------------------

           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,gs:[132]
           shl ebx,9
           xor eax,eax
           mov ax,gs:[130]         ;Ship
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax

           mov al,fs:[11fffch]
           and al,2
           jz  Not1
           mov al,gs:[129]
           xor al,8                    ; Flame
           and al,8
           mov gs:[129],al
Not1:
           mov ax,68h       ; Sprite 0
           add al,gs:[129]
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
;--------------------------------------------
           mov ax,FS:[11F812h]
           cmp ax,0
           jz  NoSat

           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,gs:[132]
           sub bx,2
           shl ebx,9
           xor eax,eax
           mov ax,gs:[130]         ;Sattelite
           add ax,34
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,0B0h       ; Sat.- Sprite
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
  NoSat:
;------------------------------------------
           mov al,FS:[11F840h]
           cmp al,0
           je  NoSat2
           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,gs:[132]
           sub bx,18
           shl ebx,9
           xor eax,eax
           mov ax,gs:[130]         ;Sattelite up
           add ax,10
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,218h      ; Sat.- Sprite
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
NoSat2:
;------------------------------------------
           mov al,FS:[11F841h]
           cmp al,0
           je  NoSat3

           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,gs:[132]
           add bx,16 ;11
           shl ebx,9
           xor eax,eax
           mov ax,gs:[130]         ;Sattelite down
           add ax,10
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,220h      ; Sat.- Sprite
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
NoSat3:
;------------------------------------------
           mov al,FS:[11F844h]
           cmp al,0
           je  NoSat3s

           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,gs:[132]
           sub bx,6
           shl ebx,9
           xor eax,eax
           mov ax,gs:[130]         ;Shield
           sub ax,7
           add eax,ebx
           add eax,931201A0h
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,240h      ; Sat.- Sprite
           mov bl,FS:[11FFFDh]
           and bl,2
           shl bl,2
           add al,bl
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
           mov ax,FS:[11F845h]
           dec ax
           mov FS:[11F845h],ax
           cmp ax,0
           jne NoSat3s
           xor ax,ax
           mov FS:[11F844h],al
NoSat3s:
;------------------------------------------

           mov bx,gs:[130]    ; x-Fighter
           mov cx,gs:[132]    ; y-Fighter

           mov al,gs:[4dh]
           rol al,1
           jc  Right
           cmp bx,462
           je  Right
           inc bx
           inc bx
  Right:
           mov al,gs:[4bh]
           rol al,1
           jc  Left
           cmp bx,192
           jng Left
           dec bx
           dec bx
  Left:
           mov al,gs:[48h]
           rol al,1
           jc  Up
           cmp cx,34
           jng Up
           dec cx
           dec cx
  Up:
           mov al,gs:[50h]
           rol al,1
           jc  Down
           cmp cx,184
           je  Down
           inc cx
           inc cx
  Down:
           mov gs:[130],bx
           mov gs:[132],cx

           mov al,gs:[29]
           rol al,1
           jc  Fire2

           mov al,gs:[128]
           ror al,1
           jc  Fire

           mov al,1
           mov gs:[128],al
           mov ax,gs:[130]
           add ax,20
           mov gs:[138],ax           ;Set Shoot
           mov ax,gs:[132]
           sub ax,18
           mov gs:[140],ax
  Fire:
           mov al,FS:[11F824h]
           ror al,1
           jc  SetSh
           mov al,FS:[11F82Ch]
           ror al,1
           jc  SetSh

           mov al,1
           mov FS:[11F82Ch],al
           mov FS:[11F824h],al        ;Set Shoot
           mov ax,gs:[130]
           add ax,20
           mov FS:[11F828h],ax
           mov FS:[11F820h],ax
           mov ax,gs:[132]
           sub ax,8
           mov FS:[11F822h],ax
           sub ax,20
           mov FS:[11F82Ah],ax
    SetSh:
           mov al,FS:[11F834h]
           ror al,1
           jc  Fire2
           mov al,FS:[11F83Ch]
           ror al,1
           jc  Fire2
           mov al,1
           mov FS:[11F83Ch],al  ;Shoot an
           mov FS:[11F834h],al
           mov ax,gs:[130]
           add ax,6
           mov FS:[11F838h],ax   ;x
           mov FS:[11F830h],ax
           mov ax,gs:[132]
           mov FS:[11F832h],ax
           mov FS:[11F83Ah],ax
  Fire2:
           mov ax,FS:[11F804h]
           and ax,512
           jz  Sp_Screen

;-------------------------------------
           mov cx,FS:[11F802h]   ;  Anz der Sprites
           mov ax,0
    HowSp: mov bx,cx
           dec bx
           shl bx,3
           mov dx,gs:[152+bx]
           cmp dx,0
           jne Nxt               ;  Ready for next Routine ???
           inc ax
     Nxt:  loop HowSp
           cmp ax,FS:[11F802h]   ;  Anz der Sprites
           jne Sp_Screen
           xor ax,ax
           mov FS:[11F804h],ax   ;  Sprite Counter
           mov ax,FS:[11F80Ch]   ;  Sprite Routine
           inc ax
           and ax,7              ;  Anz. der Spr.R.
           mov FS:[11F80Ch],ax   ;  Sprite Routine
           mov cx,200
           xor ax,ax
           xor di,di
Clear:     mov gs:[152+di],ax
           add di,8
           loop Clear
Sp_Screen:
;--------------------------------------------------


 ;  Anz der Sprites      by 11F802h         ( 8 Bit                 )
 ;  Sprite Counter       by 11F804h         ( 16 Bit  / 0 - 65535   )
 ;  Sprite Routine Var.1 by 11F806h         ( 16 Bit                )
 ;  Sprite Routine Var.2 by 11F808h         ( 16 Bit                )
 ;  Enemy Power          by 11F80Ah         ( 16 Bit                )
 ;  Sprite Routine       by 11F80Ch         ( 16 Bit                )

           mov ax,gs:[152]
           cmp ax,10
           je  NoEn
           mov ax,gs:[152]
           cmp ax,8
           je  NoEn

;-------------------------------------------------
           mov bp,FS:[11F802h]   ;Anz. der Sprites
           xor esi,esi
           xor ebx,ebx
           xor edi,edi
   s_Koll:

           mov si,gs:[152+di]
           cmp si,0
           je  NoShoot
           mov al,gs:[151+di]
           cmp al,0
           jne NoShoot
           shl si,3
           mov al,gs:[128]
           cmp al,0
           je  NotEqual
           mov bx,gs:[144]
           inc bx
           shl bx,3
           mov ax,gs:[138]      ; x1+
           mov dx,gs:[146+di]   ; x2+
           add dx,fs:[1EC003h+esi]    ;x2
           add ax,fs:[1EC003h+ebx]    ;x1
           mov cx,fs:[1EC000h+esi]    ;xs2
           sub ax,dx        ;dx=x1-x2      ;Shoot-7  x-138 y-140
           jge G1                          ;Enemy-22 x-146 y-148
           not ax                     ;not dx
           mov cx,fs:[1EC000h+ebx]    ;xs1
       G1: cmp ax,cx
           jg  NotEqual
           mov ax,gs:[140]
           xor ah,ah
           mov dx,gs:[148+di]
           add dx,fs:[1EC005h+esi]        ;-------
           add ax,fs:[1EC005h+ebx]
           xor ch,ch
           mov cl,fs:[1EC002h+esi]
           sub ax,dx
           jge G2
           not ax
           mov cl,fs:[1EC002h+ebx]
       G2: cmp ax,cx
           jg  NotEqual
           xor al,al
           mov gs:[128],al
           mov al,gs:[150+di]
           sub al,gs:[144]       ; -- Power of Shot --
           mov gs:[150+di],al
           jg  NotEqual
           call Points
           jmp NoShoot
NotEqual:
           mov al,FS:[11F824h]
           cmp al,0
           je  NotEquall
           mov bx,FS:[11F826h]
           inc bx
           shl bx,3
           mov ax,FS:[11F820h]  ; x1+
           mov dx,gs:[146+di]   ; x2+
           add dx,fs:[1EC003h+esi]         ;x2
           add ax,10
           mov cx,fs:[1EC000h+esi]
           sub ax,dx           ;dx=x1-x2      ;Shoot-7  x-138 y-140
           jge G10                            ;Enemy-22 x-146 y-148
           not ax                     ;not dx
           mov cx,30
       G10:cmp ax,cx
           jg  NotEquall
           mov ax,FS:[11F822h]
           mov dx,gs:[148+di]
           add dx,fs:[1EC005h+esi]        ;-------
           add ax,10
           xor ch,ch
           mov cl,fs:[1EC002h+esi]
           sub ax,dx
           jge G20
           not ax
           mov cx,30
       G20:cmp ax,cx
           jg  NotEquall
           xor al,al
           mov FS:[11F824h],al
           mov al,gs:[150+di]
           sub al,FS:[11F826h]       ; -- Power of Shot --
           mov gs:[150+di],al
           jg  NotEquall
           call Points
           jmp NoShoot
NotEquall:
           mov al,FS:[11F82Ch]
           cmp al,0
           je  NotEqualll
           mov bx,FS:[11F82Eh]
           inc bx
           shl bx,3
           mov ax,FS:[11F828h]  ; x1+
           mov dx,gs:[146+di]   ; x2+
           add dx,fs:[1EC003h+esi]          ;x2
           add ax,10
           mov cx,fs:[1EC000h+esi]
           sub ax,dx           ;dx=x1-x2      ;Shoot-7  x-138 y-140
           jge G100                           ;Enemy-22 x-146 y-148
           not ax                     ;not dx
           mov cx,30
      G100:cmp ax,cx
           jg  NotEqualll
           mov ax,FS:[11F82Ah]
           mov dx,gs:[148+di]
           add dx,fs:[1EC005h+esi]        ;-------
           add ax,10
           xor ch,ch
           mov cl,fs:[1EC002h+esi]
           sub ax,dx
           jge G200
           not ax
           mov cx,30
      G200:cmp ax,cx
           jg  NotEqualll
           xor al,al
           mov FS:[11F82Ch],al
           mov al,gs:[150+di]
           sub al,FS:[11F82Eh]       ; -- Power of Shot --
           mov gs:[150+di],al
           jg  NotEqualll
           call Points
           jmp NoShoot
NotEqualll:

           mov al,FS:[11F834h]
           cmp al,0
           je  NotEquallll
           mov bx,FS:[11F836h]
           inc bx
           shl bx,3
           mov ax,FS:[11F830h]  ; x1+
           mov dx,gs:[146+di]   ; x2+
           add dx,fs:[1EC003h+esi]         ;x2
           add ax,9
           mov cx,fs:[1EC100h+esi]
           sub ax,dx           ;dx=x1-x2      ;Shoot-7  x-138 y-140
           jge G1000                          ;Enemy-22 x-146 y-148
           not ax                     ;not dx
           mov cx,12
     G1000:cmp ax,cx
           jg  NotEquallll
           mov ax,FS:[11F832h]
           mov dx,gs:[148+di]
           add dx,fs:[1EC005h+esi]        ;-------
           add ax,9
           xor ch,ch
           mov cl,fs:[1EC002h+esi]
           sub ax,dx
           jge G2000
           not ax
           mov cx,12
     G2000:cmp ax,cx
           jg  NotEquallll
           xor al,al
           mov FS:[11F834h],al
           mov al,gs:[150+di]
           sub al,FS:[11F836h]       ; -- Power of Shot --
           sub al,FS:[11F836h]
           mov gs:[150+di],al
           jg  NotEquallll
           call Points
           jmp NoShoot
NotEquallll:
           mov al,FS:[11F83Ch]
           cmp al,0
           je  NotEqualllll
           mov bx,FS:[11F83Eh]
           inc bx
           shl bx,3
           mov ax,FS:[11F838h]  ; x1+
           mov dx,gs:[146+di]   ; x2+
           add dx,fs:[1EC003h+esi]          ;x2
           add ax,9
           mov cx,fs:[1EC000h+esi]
           sub ax,dx           ;dx=x1-x2      ;Shoot-7  x-138 y-140
           jge G10000                         ;Enemy-22 x-146 y-148
           not ax                     ;not dx
           mov cx,12
    G10000:cmp ax,cx
           jg  NotEqualllll
           mov ax,FS:[11F83Ah]
           mov dx,gs:[148+di]
           add dx,fs:[1EC005h+esi]        ;-------
           add ax,9
           xor ch,ch
           mov cl,fs:[1EC002h+esi]
           sub ax,dx
           jge G20000
           not ax
           mov cx,12
    G20000:cmp ax,cx
           jg  NotEqualllll
           xor al,al
           mov FS:[11F83Ch],al
           mov al,gs:[150+di]
           sub al,FS:[11F83Eh]       ; -- Power of Shot --
           sub al,FS:[11F83Eh]
           mov gs:[150+di],al
           jg  NotEqualllll
           call Points
           jmp NoShoot
NotEqualllll:
           mov ax,FS:[11F812h]
           cmp ax,0
           jz  NotEqual3
           mov ax,gs:[130]
           add ax,24
           mov dx,gs:[146+di]
           add dx,fs:[1EC003h+esi]    ;------
           add ax,fs:[1EC003h+9*8]
           mov cx,fs:[1EC000h+esi]
           sub ax,dx                    ;Sattelite-9  x-138 y-140
           jg  G13                      ;Enemy-22     x-146 y-148
           not ax
           mov cx,fs:[1EC000h+9*8]
       G13:cmp ax,cx
           jg  NotEqual3
           xor ax,ax
           xor dx,dx
           mov dl,fs:[1EC005h+esi]        ;-------
           mov al,fs:[1EC005h+9*8]
           add ax,3
           add ax,gs:[132]
           add dx,gs:[148+di]
           xor ch,ch
           mov cl,fs:[1EC002h+esi]
           sub ax,dx
           jg  G23
           not ax
           mov cl,fs:[1EC002h+9*8]
       G23:cmp ax,cx
           jg  NotEqual3
           mov al,gs:[150+di]
           dec al                 ; -- Power of Sat. --
           mov gs:[150+di],al
           jg  NotEqual3
           call Points

NotEqual3:

           mov al,FS:[11F840h]
           cmp al,0
           jz  NotEqual33
           mov ax,gs:[130]
           mov dx,gs:[146+di]
           add dx,fs:[1EC003h+esi]    ;------
           add ax,10
             ;mov cx,16
           mov cx,fs:[1EC000h+esi]
           sub ax,dx                    ;Sattelite-9  x-138 y-140
           jg  G133                     ;Enemy-22     x-146 y-148
           not ax
             ;mov cx,fs:[1EC000h+esi]
           mov cx,16
      G133:cmp ax,cx
           jg  NotEqual33
           xor ax,ax
           xor dx,dx
           mov dl,fs:[1EC005h+esi]        ;-------
           mov ax,gs:[132]
           sub ax,18
           add dx,gs:[148+di]
           mov cx,14
           sub ax,dx
           jg  G233
           not ax
           mov cl,fs:[1EC002h+esi]
      G233:cmp ax,cx
           jg  NotEqual33
           mov al,gs:[150+di]
           dec al                 ; -- Power of Sat. --
           mov gs:[150+di],al
           jg  NotEqual33
           call Points
NotEqual33:

           mov al,FS:[11F841h]
           cmp al,0
           jz  NotEqual33x
           mov ax,gs:[130]
           mov dx,gs:[146+di]
           add dx,fs:[1EC003h+esi]    ;------
           add ax,10
                  ;mov cx,16
           mov cx,fs:[1EC000h+esi]
           sub ax,dx                    ;Sattelite-9  x-138 y-140
           jg  G133x                    ;Enemy-22     x-146 y-148
           not ax
                  ;mov cx,fs:[1EC000h+esi]
           mov cx,16
     G133x:cmp ax,cx
           jg  NotEqual33x
           xor ax,ax
           xor dx,dx
           mov dl,fs:[1EC005h+esi]        ;-------
           mov ax,gs:[132]
           add ax,17
           add dx,gs:[148+di]
           xor ch,ch
           mov cx,14
           sub ax,dx
           jg  G233x
           not ax
           mov cl,fs:[1EC002h+esi]
     G233x:cmp ax,cx
           jg  NotEqual33x
           mov al,gs:[150+di]
           dec al                 ; -- Power of Sat. --
           mov gs:[150+di],al
           jg  NotEqual33x
           call Points
NotEqual33x:

           mov al,FS:[11F844h]
           cmp al,0
           jz  NotEqual33y

           mov ax,gs:[130]
           mov dx,gs:[146+di]
           add dx,fs:[1EC003h+esi]    ;------
           sub ax,10
           mov cx,fs:[1EC000h+esi]
           sub ax,dx                    ;Shield
           jg  G133y                    ;Enemy
           not ax
           mov cx,64
     G133y:cmp ax,cx
           jg  NotEqual33y
           xor ax,ax
           xor dx,dx
           mov dl,fs:[1EC005h+esi]        ;-------
           mov ax,gs:[132]
           sub ax,10
           add dx,gs:[148+di]
           xor ch,ch
                ;mov cx,32
           mov cl,fs:[1EC002h+esi]
           sub ax,dx
           jg  G233y
           not ax
                ;mov cl,fs:[1EC002h+esi]
           mov cx,32
     G233y:cmp ax,cx
           jg  NotEqual33y
           call Points
NotEqual33y:


    NoShoot:
           add di,8
           dec bp
           jnz s_Koll
;---------------------------------------------------
  NoEn:
           mov bp,FS:[11F802h]   ;Anz. der Sprites
           xor esi,esi
           xor edi,edi
   s_Koll1:mov si,gs:[152+di]
           cmp si,0
           je  NotEqual1
           mov al,gs:[151+di]
           cmp al,0
           jne NotEqual1
           shl si,3
           mov ax,gs:[130]
           mov dx,gs:[146+di]
           add dx,fs:[1EC003h+esi]    ;------
           add ax,fs:[1EC003h]
                ;mov cx,fs:[1EC000h]
           mov cx,fs:[1EC000h+esi]
           sub ax,dx                    ;Shoot-7  x-138 y-140
           jg  G11                      ;Enemy-22 x-146 y-148
           not ax
                ;mov cx,fs:[1EC000h+esi]
           mov cx,fs:[1EC000h]
       G11:cmp ax,cx
           jg  NotEqual1
           xor ax,ax
           xor dx,dx
           mov dl,fs:[1EC005h+esi]        ;-------
           mov ax,gs:[132]
           sub ax,10
           add dx,gs:[148+di]
           mov cx,7
           mov cl,fs:[1EC002h+esi]

           sub ax,dx
           jg  G22
           not ax
           mov cl,fs:[1EC002h+esi]
           mov cx,7
       G22:cmp ax,cx
           jg  NotEqual1

           mov ax,gs:[152+di]
           cmp ax,10
           jne NExtra
           mov ax,512
           mov ax,FS:[11F804h]
           xor ax,ax
           mov gs:[152+di],ax
           mov gs:[160+di],ax
           mov FS:[11F808h],ax
           mov ax,gs:[144]      ; Power Up
           inc ax
           cmp ax,7
           je  Powerup1
           mov gs:[144],ax
           jmp NotEqual1
Powerup1:
           mov ax,FS:[11F826h]      ; Power Up
           inc ax
           inc ax
           and ax,14
           cmp ax,6
           jg  Powerup2
           mov FS:[11F826h],ax
           mov FS:[11F82Eh],ax
           xor ax,ax
           mov FS:[11F824h],ax
           mov FS:[11F82Ch],ax
           jmp NotEqual1
Powerup2:
           mov ax,FS:[11F836h]      ; Power Up
           inc ax
           cmp ax,4
           je  NotEqual1
           mov FS:[11F836h],ax
           mov FS:[11F83Eh],ax
           xor ax,ax
           mov FS:[11F834h],ax
           mov FS:[11F83Ch],ax
           jmp NotEqual1

  NExtra:
           mov ax,gs:[152+di]
           cmp ax,8
           jne NExtra2
           mov ax,1023
           mov ax,FS:[11F804h]
           xor ax,ax
           mov gs:[152+di],ax       ;Satellite
           mov gs:[160+di],ax
           mov FS:[11F808h],ax

           mov al,FS:[11F812h]
           cmp al,1
           je  St2
           mov ax,1
           mov FS:[11F812h],ax
           jmp NotEqual1
St2:       mov al,FS:[11F840h]
           cmp al,1
           je  St3
           mov ax,1
           mov FS:[11F840h],ax
           jmp NotEqual1
St3:       mov al,FS:[11F841h]
           cmp al,1
           je  St4
           mov al,1
           mov FS:[11F841h],al
           jmp NotEqual1
St4:       mov FS:[11F844h],al
           mov ax,3000
           mov FS:[11F845h],ax
           jmp NotEqual1
NExtra2:
           mov ax,1                ;Loose a Life
           mov FS:[11F816h],ax
NotEqual1:
           add di,8
           dec bp
           jnz s_Koll1
;-------------------------------------------------

           mov ax,60h
           mov ds,ax
           mov bx,FS:[11F80Ch]
           shl bx,1                ;Sprite Moving
           mov di,offset Spr_Rt
           mov cx,[bx+di]
           jmp cx
BacktoGame:


           xor eax,eax
    allSp:
           mov cx,60h
           mov ds,cx
           mov bx,ax
           shl bx,3
           xor ecx,ecx
           xor edx,edx
           mov cx,gs:[146+bx]
           mov dx,gs:[148+bx]
           xor dh,dh
           shl edx,9
           add ecx,edx
           add ecx,931201A0h
           mov di,offset CHG_Des
           mov [di+2],ecx                ; Show all Enemy Sprites
           mov cx,gs:[152+bx]
           cmp cx,0
           je  NSprite
           shl cx,3
           and cx,0FFF8h
           add cx,68h
           mov ds,cx
           mov cx,48h
           mov es,cx
           call Sprite4
NSprite:   inc al
           cmp al,FS:[11F802h]    ;Sprite Anz
           jne allSp

NoEnemys:

           mov ax,60h
           mov ds,ax
           xor ebx,ebx
           mov bx,fs:[11F800h]
           dec bx
           mov fs:[11F800h],bx
           mov ax,bx
           and ax,512
           jz  NTree

           and bx,511
           mov eax,9312E1A0h             ; Tree
           add eax,ebx
           mov di,offset CHG_Des
           mov [di+2],eax
           mov ax,138h       ; Sprite 2 = Tree
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
NTree:

NoSprites:

   ;-------------------------------
           mov al,gs:[2020]
           cmp al,0
           je  NoSndxx

           mov ax,60h
           mov ds,ax
           mov eax,93124060h+135*512            ; Sound Level
           mov di,offset CHG_Des
           mov [di+2],eax
DMATemp1:  mov dx,0dh
           in  al,dx
           mov bl,al
           and bl,128
           jz  SLW
           not al
      SLW:
           shr al,2
           and ax,15
           shl ax,3
           add ax,348h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
    ;-----------------------------------
           mov ax,60h
           mov ds,ax
           mov eax,93124060h+135*512+306            ; Sound Level
           mov di,offset CHG_Des
           mov [di+2],eax
DMATemp2:  mov dx,0dh
           in  al,dx
           mov bl,al
           and bl,128
           jz  SLW2
           not al
      SLW2:
           shr al,2
           and ax,15
           shl ax,3
           add ax,348h
           mov ds,ax
           mov ax,48h       ; Chg_Des
           mov es,ax
           call Sprite4
NoSndxx:
;-------------------------------------------
           mov dx,3dah
Retr:                             ; Wait Retrace
           in  al,dx
           and al,8
           jz  Retr

           mov ax,38h        ;Vga-Des.
           mov ds,ax
           mov ax,20h        ;Copy to VGA-RAM
           mov es,ax
           xor di,di
           xor si,si

           mov cx,100
Cpy:       call Move         ;Faster than rep movsd ???
           add si,0C0h
           loop Cpy

           mov ax,40h
           mov ds,ax
           xor si,si
           mov cx,68

Cpy2:      call Move         ;Faster than rep movsd ???
           add si,0C0h
           loop Cpy2

           mov al,gs:[1]
           rol al,1
           jc  Esc_Key
Ende:

           mov al,36h
           out 43h,al
           mov al,255
           out 40h,al
           out 40h,al

           mov al,4
           out 8,al
           out 0d0h,al

           call Init_RM

           mov ax,3
           int 10h

           mov dx,3f2h
           mov al,0
           out dx,al

           mov ax,4c00h
           int 21h
           ret

SpRt1:                                ; Start of the 1st Sprite R.
           mov dx,3                   ; Power of Enemy
           mov FS:[11F80Ah],dx
           mov ax,22       ;40        ;Sprite Nummer
           mov FS:[11F808h],ax

           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,5                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset
s_set:
           add bx,123
           and bx,511
           mov gs:[146+di],bx
           mov gs:[150+di],dx
           add di,8
           loop s_set
notset:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor esi,esi
           xor edi,edi
sprt:
           mov di,cx
           dec di
           shl di,3
           add si,200h         ; 1st Enemy Routine
           and si,7ffh
           mov bx,gs:[146+di]
           mov ax,cx
           and ax,0  ; Speed of Sprites
           inc ax
           inc ax
           sub bx,ax
           and bx,511
           mov ax,bx
           mov gs:[146+di],bx
           and ax,504
           jnz no_set
           and dx,512           ; How long ?
           jnz if_z
           mov ax,10            ; <> 0
           mov gs:[152+di],ax
           jmp no_set
    if_z:  xor ax,ax            ; = 0
           mov gs:[152+di],ax
   no_set: mov al,fs:[1F1800h+ebx+esi]
           mov gs:[148+di],al

           call Expl

           dec cx
           jnz sprt

           mov al,gs:[129]
           shr al,3
           and ax,1
           add ax,FS:[11F808h]                   ;Sprite Nummer
           mov cx,FS:[11F802h]

    fl:    mov bx,cx
           dec bx
           shl bx,3
           mov dx,gs:[152+bx]
           cmp dx,0
           je no_anm
           mov dl,gs:[151+bx]
           cmp dl,0
           jnz no_anm
           mov gs:[152+bx],ax
no_anm:    loop fl
           jmp BacktoGame              ; End of the Spr Routine
SpRt7:                                ; Start of the 1st Sprite R.
           mov dx,1                   ; Power of Enemy
           mov FS:[11F80Ah],dx
           mov ax,64                  ;Sprite Nummer
           mov FS:[11F808h],ax

           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,5                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notsetx
s_setx:
           add bx,123
           and bx,511
           mov gs:[146+di],bx
           mov gs:[150+di],dx
           add di,8
           loop s_setx
notsetx:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor esi,esi
           xor edi,edi
sprtx:
           mov di,cx
           dec di
           shl di,3
                          ; 1st Enemy Routine
           mov bx,gs:[146+di]
           mov ax,cx
           and ax,0  ; Speed of Sprites
           inc ax
           inc ax
           sub bx,ax
           and bx,511
           mov ax,bx
           mov gs:[146+di],bx
           and ax,504
           jnz no_setx
           and dx,512           ; How long ?
           jnz if_zx
           mov ax,10            ; <> 0
           mov gs:[152+di],ax
           jmp no_setx
    if_zx: xor ax,ax            ; = 0
           mov gs:[152+di],ax
   no_setx:mov ax,cx
           shl ax,4
           sub bx,ax
           and bx,511
           mov al,fs:[1F0A00h+ebx]
           mov gs:[148+di],al

           call Expl

           dec cx
           jnz sprtx

           mov ax,FS:[11F810h]
           shr al,2
           and ax,15
           add ax,FS:[11F808h]                   ;Sprite Nummer
           mov cx,FS:[11F802h]

    flx:   mov bx,cx
           dec bx
           shl bx,3
           mov dx,gs:[152+bx]
           cmp dx,0
           je no_anmx
           mov dl,gs:[151+bx]
           cmp dl,0
           jnz no_anmx
           mov gs:[152+bx],ax
no_anmx:   loop flx
           jmp BacktoGame              ; End of the Spr Routine

SpRt2:                                 ; Start of the 1st Sprite R.
           mov dx,1                    ; Power of Enemy
           mov FS:[11F80Ah],dx
           mov ax,16                   ;Sprite Nummer
           mov FS:[11F808h],ax

           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,10                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset1
s_set1:
           xor bx,di
           xor bx,cx
           xor bx,123
           xor al,cl
           add bx,147
           and bx,511
           add al,67
           and al,127
           add al,32
           mov gs:[146+di],bx
           mov gs:[148+di],al
           mov gs:[150+di],dx
           add di,8
           loop s_set1
notset1:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor esi,esi
           xor edi,edi
sprt11:
           mov di,cx
           dec di
           shl di,3                ; 2nd Enemy Routine
           mov bx,gs:[146+di]
           mov ax,cx
           and ax,1  ; Speed of Sprites
           inc ax
           inc ax
           sub bx,ax
           and bx,511
           mov ax,bx
           mov gs:[146+di],bx
           and ax,504
           jnz no_set1
           and dx,512           ; How long ?
           jnz if_z1
           mov ax,10            ; <> 0
           mov gs:[152+di],ax
           jmp no_set1
    if_z1: xor ax,ax            ; = 0
           mov gs:[152+di],ax
  no_set1:
           call Expl

           dec cx
           jnz sprt11

           mov al,gs:[129]
           shr al,3
           and ax,1
           add ax,FS:[11F808h]                   ;Sprite Nummer
           mov cx,FS:[11F802h]

    fl1:   mov bx,cx
           dec bx
           shl bx,3
           mov dx,gs:[152+bx]
           cmp dx,0
           je no_anm1
           mov dl,gs:[151+bx]
           cmp dl,0
           jnz no_anm1
           mov gs:[152+bx],ax
no_anm1:   loop fl1
           jmp BacktoGame              ; End of the Spr Routine

SpRt8:                                 ; Start of the 1st Sprite R.
           mov dx,50                  ; Power of Enemy
           mov FS:[11F80Ah],dx
           xor ax,ax
           mov gs:[151+di],al
           mov gs:[150],dx
           mov ax,40                   ;Sprite Nummer
           mov FS:[11F808h],ax

           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,1                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset1x
s_set1x:
           xor bx,bx
           mov al,33
           mov gs:[146+di],bx
           mov gs:[148+di],al
           mov gs:[150+di],dx
           add di,8
           loop s_set1x
notset1x:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor esi,esi
           xor edi,edi
sprt11x:
           mov di,cx
           dec di
           shl di,3                ; 2nd Enemy Routine
           mov bx,gs:[146+di]      ; Speed of Sprites
           dec bx
           dec bx
           and bx,511
           mov ax,bx
           mov gs:[146+di],bx
           and ax,504
           jnz no_set1x
           and dx,512           ; How long ?
           jnz if_z1x
           mov ax,10            ; <> 0
           mov gs:[152+di],ax
           jmp no_set1x
    if_z1x:xor ax,ax            ; = 0
           mov gs:[152+di],ax
  no_set1x:
           dec cx
           jnz sprt11x

           mov al,gs:[129]
           shr al,3
           and ax,1
           add ax,FS:[11F808h]                   ;Sprite Nummer
           mov cx,FS:[11F802h]

    fl1x:  mov bx,cx
           dec bx
           shl bx,3
           mov dx,gs:[152+bx]
           cmp dx,0
           je no_anm1x
           mov dl,gs:[151+bx]
           cmp dl,0
           jnz no_anm1x
           mov gs:[152+bx],ax
no_anm1x:  loop fl1x

           jmp BacktoGame              ; End of the Spr Routine

SpRt9:                                 ; Start of the 1st Sprite R.
           mov dx,4                  ; Power of Enemy
           mov FS:[11F80Ah],dx
           xor ax,ax
           mov gs:[151+8],al
           mov gs:[150+8],dx
           mov gs:[151],al
           mov gs:[150],dx
           mov al,108                  ;Sprite Nummer 2
           mov gs:[152],al

           inc word ptr FS:[11F804h]  ;Sprite Count
           mov cx,2                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset1xz
s_set1xz:
           xor bx,bx
           mov gs:[150],bx
           mov gs:[150+8],bx
notset1xz:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           xor esi,esi
           xor edi,edi
sprt11xz:
           xor eax,eax
           xor ebx,ebx
           mov ax,FS:[11F804h]
           not ax
           and ax,511
           xor ecx,ecx
           mov cl,FS:[1F0000h+eax+16*512]
           shl ax,1
           and cl,15
           mov dl,cl
           add dl,81
           mov gs:[152+8],dl

           shr cl,1
           mov bl,cl
           add ax,cx
           not bl
           and bl,31
           add bl,8
           mov gs:[148+8],bl
           mov cx,ax
           and cx,511
           mov gs:[146+8],cx
           add cx,89
           mov gs:[146],cx
           xor di,di
           mov ax,FS:[11F804h]
           and ax,256+512+1024           ;x
           jz  no_set1xz
           xor ax,ax            ; = 0
           mov gs:[152+8],ax
           mov gs:[152],ax
           mov gs:[152+16],ax
 no_set1xz:
           mov al,gs:[152+16]
           cmp al,0
           jnz goon
           mov bl,gs:[148+8]
           add bl,40
           and bl,255-7
           mov gs:[148],al
           mov al,gs:[148+8]
           not al
           and al,7
           add al,bl
           mov gs:[148],al
           jmp goon3
     goon:
           mov al,gs:[148]
           add al,2
           mov gs:[148],al
           cmp al,200
           jb  goon3
           sub al,2
           mov gs:[148],al
    goon3:
           mov ax,gs:[146]
           add ax,4
           sub ax,gs:[130]
           and ax,511-7
           xor bh,bh
           mov bl,gs:[132]
           sub bl,gs:[148]
           and bl,255-7
           cmp ax,bx
           jne goon2
           mov al,1
           mov gs:[152+16],al
     goon2:
           jmp BacktoGame              ; End of the Spr Routine

SpRt3:                                 ; Start of the 1st Sprite R.
           mov dx,15                   ; Power of Enemy
           mov FS:[11F80Ah],dx
           mov ax,61 ;25                  ;Sprite Nummer
           mov FS:[11F808h],ax

           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,8                  ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset2
s_set2:
           add bx,64
           and bx,511
           mov gs:[146+di],bx
           mov gs:[150+di],dx
           add di,8
           loop s_set2
notset2:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor esi,esi
           xor edi,edi
sprt33:
           mov di,cx
           dec di
           shl di,3
           add si,600h         ; 1st Enemy Routine
           and si,1fffh
           mov bx,gs:[146+di]
           mov ax,cx
           and ax,0  ; Speed of Sprites
           inc ax
           inc ax
           inc ax
           sub bx,4
           and bx,511
           mov ax,bx
           mov gs:[146+di],bx
           and ax,504
           jnz no_set2
           and dx,512           ; How long ?
             jnz if_z2
           mov ax,10            ; <> 0
           mov gs:[152+di],ax
           mov FS:[11F806h],ax  ;Spr.on Screen
           jmp no_set2
    if_z2: xor ax,ax            ; = 0
           mov gs:[152+di],ax
   no_set2:mov si,cx
           and si,1
           shl si,9
           mov al,fs:[1F0600h+ebx+esi]
           mov gs:[148+di],al

           call Expl

           dec cx
           jnz sprt33

           mov ax,FS:[11F808h]                   ;Sprite Nummer
           mov cx,FS:[11F802h]

    fl2:   mov bx,cx
           dec bx
           shl bx,3
           mov dx,gs:[152+bx]
           cmp dx,0
           je no_anm2
           mov dl,gs:[151+bx]
           cmp dl,0
           jnz no_anm2
           mov gs:[152+bx],ax
no_anm2:   loop fl2
           jmp BacktoGame              ; End of the Spr Routine

SpRt4:                                 ; Start of the 1st Sprite R.
           mov dx,3                    ; Power of Enemy
           mov FS:[11F80Ah],dx
           mov ax,20                   ;Sprite Nummer
           mov FS:[11F808h],ax

           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,3                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset5
s_set5:
           add bx,123
           and bx,511
           mov gs:[146+di],bx
           mov gs:[150+di],dx
           add di,8
           loop s_set5
notset5:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor esi,esi
           xor edi,edi
sprt55:
           mov di,cx
           dec di
           shl di,3
           add si,200h         ; 1st Enemy Routine
           and si,7ffh
           mov bx,gs:[146+di]
           mov ax,cx
           and ax,0  ; Speed of Sprites
           inc ax
           inc ax
           sub bx,ax
           and bx,511
           mov ax,bx
           mov gs:[146+di],bx
           and ax,504
           jnz no_set5
           and dx,512           ; How long ?
            jnz if_z5
           mov ax,10            ; <> 0
           mov gs:[152+di],ax
           mov FS:[11F806h],ax  ;Spr.on Screen
           jmp no_set5
    if_z5: xor ax,ax            ; = 0
           mov gs:[152+di],ax
   no_set5:mov al,fs:[1F0000h+ebx+esi]
           mov gs:[148+di],al

           call Expl

    wtr5:
           dec cx
           jnz sprt55

           mov al,gs:[129]
           shr al,3
           and ax,1
           add ax,FS:[11F808h]                   ;Sprite Nummer
           mov cx,FS:[11F802h]

    fl5:   mov bx,cx
           dec bx
           shl bx,3
           mov dx,gs:[152+bx]
           cmp dx,0
           je no_anm5
           mov dl,gs:[151+bx]
           cmp dl,0
           jnz no_anm5
           mov gs:[152+bx],ax
no_anm5:   loop fl5
           jmp BacktoGame           ; End of the Spr Routine

SpRt5:                                 ; Start of the 1st Sprite R.
           mov ax,FS:[11F804h]
           cmp ax,2
           jne NMS2
           mov ax,10                   ;Sprite Nummer
           mov FS:[11F808h],ax
           mov gs:[152],ax
    NMS2:
           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,1                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset6
s_set6:
           mov bx,510
           mov gs:[146],bx
           mov gs:[150],dx
notset6:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor edi,edi
sprt66:                     ; 1st Enemy Routine
           mov bx,gs:[146]  ; Speed of Sprites
           dec bx
           dec bx
           and bx,510
           mov gs:[146],bx
           mov al,fs:[1F1A00h+ebx]
           mov gs:[148],al

           mov ax,gs:[146]
           cmp ax,2
           jne NoCl
           xor ax,ax
           mov gs:[152],ax
           mov ax,512
           mov FS:[11F804h],ax
   NoCl:

           jmp BacktoGame           ; End of the Spr Routine

SpRt6:                                 ; Start of the 1st Sprite R.
           mov dx,3                    ; Power of Enemy
           mov FS:[11F80Ah],dx

           mov ax,FS:[11F804h]
           cmp ax,2
           jne NMS1
           mov ax,8                   ;Sprite Nummer
           mov FS:[11F808h],ax
           mov gs:[152],ax
    NMS1:
           mov ax,FS:[11F804h]
           inc ax                     ;Sprite Count
           mov FS:[11F804h],ax
           mov cx,1                   ; Anz of Sprites on Screen
           mov FS:[11F802h],cx
           xor edi,edi
           cmp ax,1
           jne notset7
s_set7:
           mov bx,510
           mov gs:[146],bx
           mov gs:[150],dx
notset7:
           xor ebx,ebx
           mov cx,FS:[11F802h]
           mov dx,FS:[11F804h]
           xor edi,edi
sprt77:                     ; 1st Enemy Routine
           mov bx,gs:[146]  ; Speed of Sprites
           dec bx
           dec bx
           and bx,510
           mov gs:[146],bx
           mov al,fs:[1F0400h+ebx]
           mov gs:[148],al

           mov ax,gs:[146]
           cmp ax,2
           jne NoCl7
           xor ax,ax
           mov gs:[152],ax
           mov ax,512
           mov FS:[11F804h],ax
   NoCl7:
           jmp BacktoGame           ; End of the Spr Routine


Init_PM:   cli
           pop cx
           xor eax,eax
           mov cr0,eax
           mov cr3,eax
           xor ebx,ebx
           mov ax,cs
           mov bx,offset Keys
           shl eax,4
           add eax,ebx
           mov di,offset Key_Des
           mov cs:[di+2],eax
           mov al,93h
           mov cs:[di+5],al

           xor eax,eax
           xor ebx,ebx
           xor edx,edx
           mov ax,cs
           mov ds,ax
           mov ax,cs
           shl eax,4
           mov ebx,eax
           mov dx,offset GDT
           add eax,edx                      ; GDT setting
           mov di,offset Base
           mov [di],eax
           mov di,offset GDTPtr
           lgdt [di]

           xor eax,eax
           mov ax,offset IDT
           add eax,ebx
           mov di,offset IDTPtr             ; IDT setting
           mov bx,offset R_IDT
           mov  [di+2],eax
           mov  ax,160
           mov  [di],ax
           sidt [bx]
           lidt [di]

           xor eax,eax
           mov ax,ss
           mov bx,offset SS_Seg
           mov cs:[bx],ax
           mov cs:[bx+2],sp
           shl eax,4                         ; Stack
           mov dword ptr Stack_D+2,eax
           mov al,92h
           mov byte  ptr Stack_D+5,al

           xor eax,eax
           mov ax,cs
           mov word ptr Code_Seg,ax
           shl eax,4
           mov di,offset CodeDes
           mov cs:[di+2],eax                 ; Code
           mov bl,9Bh
           mov cs:[di+5],bl
           mov di,offset CS__Des
           mov cs:[di+2],eax                 ; Code
           mov bl,93h
           mov cs:[di+5],bl

           mov eax,1
           mov cr0,eax
           db 234
           dw offset P_Mode,8
P_Mode:    mov ax,10h
           mov ds,ax
           mov es,ax
           mov fs,ax
           mov ax,58h
           mov gs,ax
           mov ax,50h
           mov ss,ax
           cli
           jmp cx

Init_RM:   cli
           pop cx
           mov ax,18h
           mov ds,ax
           mov es,ax
           mov fs,ax
           mov gs,ax
           mov ss,ax
           xor eax,eax
           mov cr0,eax
           mov cr3,eax
           db 234
           dw offset R_Mode
Code_Seg   dw 0
R_mode:    mov di,offset R_IDT
           lidt cs:[di]
           mov bx,offset SS_Seg
           mov ax,cs:[bx]
           mov ss,ax
           mov sp,cs:[bx+2]
           and esp,65535
           sti
           jmp cx

Scr:       mov ax,FS:[11F400h+edi]
           inc ax
           cmp ax,319
           jng WT                              ; Scroll Ebene
           xor ax,ax
WT:        mov FS:[11F400h+edi],ax
           inc di
           inc di
           loop Scr
           ret

Sprite:    mov bp,ds:[0]
           and bp,255
           cld
           mov si,ds:[0]
           and si,255              ;Durch 4 Teilbare Lnge
           shl si,2
           add si,17               ; Lng * 4 = Sichtbare Lnge
           xor cx,cx
           xor dx,dx
  Spr:     mov bx,dx
           shl bx,2
           mov cl,[bx+13]
           mov di,[bx+15]
           rep movsd                         ; Sprite
           inc dx
           cmp dx,bp
           jne Spr
           ret

Sprite4:   cld
           xor cx,cx
           xor dx,dx
           xor bx,bx
           mov bp,ds:[11]
           mov si,bp
           shl si,2
           add si,17
  Spr4:                       ;Perfect Sprite Routine
           mov dl,[bx+13]
           mov cl,dl
           mov di,[bx+15]
           shr cl,2
           rep movsd                         ; Sprite
           mov cl,dl
           and cl,3
           rep movsb
           add bx,4
           dec bp
           jnz Spr4
           ret

Points:
           mov al,FS:[11F80Ah]
           mov gs:[150+di],al
           mov al,1
           mov ah,11
           mov gs:[151+di],ax
           mov dl,FS:[1EC009h+esi]
           xor dh,dh
           mov ax,gs:[146+di]
           sub ax,dx
           and ax,511
           mov gs:[146+di],ax
           mov al,FS:[11F81Ah]
           inc al
           mov FS:[11F81Ah],al
           cmp al,10
           jne NMP
           mov al,0
           mov FS:[11F81Ah],al
           mov al,FS:[11F81Bh]
           inc al
           mov FS:[11F81Bh],al
           cmp al,10
           jne NMP
           mov al,0
           mov FS:[11F81Bh],al
           mov al,FS:[11F81Ch]
           inc al
           mov FS:[11F81Ch],al
           cmp al,10
           jne NMP
           mov al,0
           mov FS:[11F81Ch],al
           mov al,FS:[11F81Dh]
           inc al
           mov FS:[11F81Dh],al
           cmp al,10
           jne NMP
           mov al,0
           mov FS:[11F81Dh],al
           mov al,FS:[11F81Eh]
           inc al
           mov FS:[11F81Eh],al
           cmp al,10
           jne NMP
           mov al,0
           mov FS:[11F81Eh],al
           mov al,FS:[11F81Fh]
           inc al
           mov FS:[11F81Fh],al
           cmp al,10
           jne NMP
           mov al,0
           mov FS:[11F81Fh],al
   NMP:    ret

Expl:
           mov al,gs:[151+di]
           cmp al,0
           je  WTTR
           mov bx,FS:[11F804h]
           and bx,3
           jnz WTTR
           mov ax,gs:[151+di]
           inc ah
           mov gs:[152+di],ah
           cmp ah,15              ;Explosion
           jne WTTR
           xor ah,ah
           mov al,3
           mov gs:[150+di],ax
           mov ax,5
           mov gs:[146+di],ax
WTTR:      ret

Move:      movsd    ;1  0
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           movsd    ;1  1
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           movsd    ;1  2
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           movsd    ;1  3
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           movsd    ;1  4
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           movsd    ;1  5
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           movsd    ;1  6
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           movsd    ;1  7
           movsd    ;2
           movsd    ;3
           movsd    ;4
           movsd    ;5
           movsd    ;6
           movsd    ;7
           movsd    ;8
           movsd    ;9
           movsd    ;0
           ret

EXP:       push ax
           push dx
           mov al,0
           mov dx,3f2h
           out dx,al
           xor al,al
           mov dx,3c8h
           out dx,al
           mov al,3fh
           inc dx
           out dx,al
           out dx,al
           out dx,al
           pop dx
           pop ax
           iret

IRQ:       push ax
           mov al,20h
           out 020h,al
           pop ax
           iret
DMA:
           mov GS:[2004],al
           mov GS:[2006],dx

DMAPage:   mov dx,87h
           in al,dx
           inc al           ;INC Page Register
           and al,1fh
           or al,20h
           out dx,al

SBPort2:   mov dx,21eh
SBwaitx1:  in al,dx        ; Wait for DSP
           and al,128
           jz SBwaitx1

SBPort1:   mov dx,21ch
           mov al,14h      ; DSP - Command for DMA Playing
           out dx,al
@l1:       in al,dx
           and al,128      ; Wait for DSP
           jnz @l1
           mov al,255      ; Set Length Lo
           out dx,al
@l2:       in al,dx
           and al,128      ; Wait for DSP
           jnz @l2
           mov al,255
           out dx,al       ; Set Length Hi

           mov al,20h
           out 20h,al
           mov  al,GS:[2004]
           mov  dx,GS:[2006]
           iret

Key:       push ax
           push dx
           push di
           mov dx,60h
           in  al,dx
           mov di,ax
           and di,127
           mov gs:[di],al
           mov al,20h
           out 20h,al
           pop di
           pop dx
           pop ax
           iret

         ; Globale Descriptor Tabelle

    GDT    dq    0                    ;00h
CodeDes    dq    008f00000000FFFFh    ;08h    ; Code Des.
DataDes    dq    008F93000000FFFFh    ;10h    ; 4 Gigabyte
RealDes    dq    000092000000FFFFh    ;18h    ; Real-Modes Des.
VGA_Des    dq    008F930A0000FFFFh    ;20h    ; A0000h im RAM
BKG1Des    dq    008F93100000FFFFh    ;28h    ; 1. 64000 Bytes
BKG2Des    dq    008F9310FA00FFFFh    ;30h    ; 2. 64000 Bytes
MS1_Des    dq    008F93124060FFFFh    ;38h    ; 1.Screen im RAM
MS2_Des    dq    008F93130860FFFFh    ;40h    ; 2.Screen im RAM
CHG_Des    dq    008F93124060FFFFh    ;48h    ; Changing Des.
Stack_D    dq    008F93000000FFFFh    ;50h    ; Stack
Key_Des    dq    008F93000000FFFFh    ;58h    ; Key Table
CS__Des    dq    008F93000000FFFFh    ;60h    ; Code
S01_Des    dq    008F93150000FFFFh    ;68h    ; Sprite 0  Fighter 1
           dq    008F93150000FFFFh    ;70h    ; Sprite 1  Fighter 2
           dq    008F93150000FFFFh    ;78h    ; Sprite 2  Shoot 1
           dq    008F93150000FFFFh    ;80h    ; Sprite 3  Shoot 2
           dq    008F93150000FFFFh    ;88h    ; Sprite 4  Shoot 3
           dq    008F93150000FFFFh    ;90h    ; Sprite 5  Shoot 4
           dq    008F93150000FFFFh    ;98h    ; Sprite 6  Shoot 5
           dq    008F93150000FFFFh    ;a0h    ; Sprite 7  Shoot 6
           dq    008F93150000FFFFh    ;a8h    ; Sprite 8  SatPower
           dq    008F93150000FFFFh    ;b0h    ; Sprite 9  Satellite
           dq    008F93150000FFFFh    ;b8h    ; Sprite 10 Power Up
           dq    008F93150000FFFFh    ;c0h    ; Sprite 11 Explosion 1
           dq    008F93150000FFFFh    ;c8h    ; Sprite 12 Explosion 2
           dq    008F93150000FFFFh    ;d0h    ; Sprite 13 Explosion 3
           dq    008F93150000FFFFh    ;d8h    ; Sprite 14 Explosion 4
           dq    008F93150000FFFFh    ;e0h    ; Sprite 15 Explosion 5
           dq    008F93150000FFFFh    ;e8h    ; Sprite 16 E Small 1.1 r
           dq    008F93150000FFFFh    ;f0h    ; Sprite 17 E Small 1.2 r
           dq    008F93150000FFFFh    ;f8h    ; Sprite 18 E Small 2.1 l
           dq    008F93150000FFFFh    ;100h   ; Sprite 19 E Small 2.2 l
           dq    008F93150000FFFFh    ;108h   ; Sprite 20 E Long  3.1
           dq    008F93150000FFFFh    ;110h   ; Sprite 21 E Long  3.2
           dq    008F93150000FFFFh    ;118h   ; Sprite 22 E Big   4.1
           dq    008F93150000FFFFh    ;120h   ; Sprite 23 E Big   4.2
           dq    008F93150000FFFFh    ;128h   ; Sprite 24 E Round 5   l
           dq    008F93150000FFFFh    ;130h   ; Sprite 25 E Round 6   r
           dq    008F93150000FFFFh    ;138h   ; Sprite 26 E Tree
           dq    008F93150000FFFFh    ;140h   ; Sprite 27   0
           dq    008F93150000FFFFh    ;148h   ; Sprite 28   1
           dq    008F93150000FFFFh    ;150h   ; Sprite 29   2
           dq    008F93150000FFFFh    ;158h   ; Sprite 30   3
           dq    008F93150000FFFFh    ;160h   ; Sprite 31   4  Numbers
           dq    008F93150000FFFFh    ;168h   ; Sprite 32   5
           dq    008F93150000FFFFh    ;170h   ; Sprite 33   6
           dq    008F93150000FFFFh    ;178h   ; Sprite 34   7
           dq    008F93150000FFFFh    ;180h   ; Sprite 35   8
           dq    008F93150000FFFFh    ;188h   ; Sprite 36   9
           dq    008F93150000FFFFh    ;190h   ; Sprite 37 GAME OVER
           dq    008F93150000FFFFh    ;198h   ; Sprite 38 GET READY
           dq    008F93150000FFFFh    ;1A0h   ; Sprite 39 Station
           dq    008F93150000FFFFh    ;1A8h   ; Sprite 40 Big Ship 1
           dq    008F93150000FFFFh    ;1B0h   ; Sprite 41 Big Ship 2
           dq    008F93150000FFFFh    ;1B8h   ; Sprite 42 Shoot 1u
           dq    008F93150000FFFFh    ;1C0h   ; Sprite 43 Shoot 2u
           dq    008F93150000FFFFh    ;1C8h   ; Sprite 44 Shoot 3u
           dq    008F93150000FFFFh    ;1D0h   ; Sprite 45 Shoot 4u
           dq    008F93150000FFFFh    ;1D8h   ; Sprite 46 Shoot 5u
           dq    008F93150000FFFFh    ;1E0h   ; Sprite 47 Shoot 6u
           dq    008F93150000FFFFh    ;1E8h   ; Sprite 48 Shoot 1d
           dq    008F93150000FFFFh    ;1F0h   ; Sprite 49 Shoot 2d
           dq    008F93150000FFFFh    ;1F8h   ; Sprite 50 Shoot 3d
           dq    008F93150000FFFFh    ;200h   ; Sprite 51 Shoot 4d
           dq    008F93150000FFFFh    ;208h   ; Sprite 52 Shoot 5d
           dq    008F93150000FFFFh    ;210h   ; Sprite 53 Shoot 6d
           dq    008F93150000FFFFh    ;218h   ; Sprite 54 Sat up
           dq    008F93150000FFFFh    ;220h   ; Sprite 55 Sat down
           dq    008F93150000FFFFh    ;228h   ; Sprite 56 Shoot 1ud
           dq    008F93150000FFFFh    ;230h   ; Sprite 57 Shoot 2ud
           dq    008F93150000FFFFh    ;238h   ; Sprite 58 Shoot 3ud
           dq    008F93150000FFFFh    ;240h   ; Sprite 59 Shield 1
           dq    008F93150000FFFFh    ;248h   ; Sprite 60 Shield 2
           dq    008F93150000FFFFh    ;250h   ; Sprite 61 small Globe
           dq    008F93150000FFFFh    ;258h   ; Sprite 62 big   Globe
           dq    008F93150000FFFFh    ;260h   ; Sprite 63 Station 2
           dq    008F93150000FFFFh    ;268h   ; Sprite 64 1  Rock
           dq    008F93150000FFFFh    ;270h   ; Sprite 65 2  Rock
           dq    008F93150000FFFFh    ;278h   ; Sprite 66 3  Rock
           dq    008F93150000FFFFh    ;280h   ; Sprite 67 4  Rock
           dq    008F93150000FFFFh    ;288h   ; Sprite 68 5  Rock
           dq    008F93150000FFFFh    ;290h   ; Sprite 69 6  Rock
           dq    008F93150000FFFFh    ;298h   ; Sprite 70 7  Rock
           dq    008F93150000FFFFh    ;2A0h   ; Sprite 71 8  Rock
           dq    008F93150000FFFFh    ;2A8h   ; Sprite 72 9  Rock
           dq    008F93150000FFFFh    ;2B0h   ; Sprite 73 10 Rock
           dq    008F93150000FFFFh    ;2B8h   ; Sprite 74 11 Rock
           dq    008F93150000FFFFh    ;2C0h   ; Sprite 75 12 Rock
           dq    008F93150000FFFFh    ;2C8h   ; Sprite 76 13 Rock
           dq    008F93150000FFFFh    ;2D0h   ; Sprite 77 14 Rock
           dq    008F93150000FFFFh    ;2D8h   ; Sprite 78 15 Rock
           dq    008F93150000FFFFh    ;2E0h   ; Sprite 79 16 Rock
           dq    008F93150000FFFFh    ;2E8h   ; Sprite 80 Big Rock
           dq    008F93150000FFFFh    ;2F0h   ; Sprite 81 Dragon 1
           dq    008F93150000FFFFh    ;2F8h   ; Sprite 82 Dragon 2
           dq    008F93150000FFFFh    ;300h   ; Sprite 83 Dragon 3
           dq    008F93150000FFFFh    ;308h   ; Sprite 84 Dragon 4
           dq    008F93150000FFFFh    ;310h   ; Sprite 85 Dragon 5
           dq    008F93150000FFFFh    ;318h   ; Sprite 86 Dragon 6
           dq    008F93150000FFFFh    ;320h   ; Sprite 87 Dragon 7
           dq    008F93150000FFFFh    ;328h   ; Sprite 88 Dragon 8
           dq    008F93150000FFFFh    ;330h   ; Sprite 89 Dragon 9
           dq    008F93150000FFFFh    ;338h   ; Sprite 90 Dragon 10
           dq    008F93150000FFFFh    ;340h   ; Sprite 91 Dragon 11
           dq    008F93150000FFFFh    ;348h   ; Sprite 92  Sound 1
           dq    008F93150000FFFFh    ;350h   ; Sprite 93  Sound 2
           dq    008F93150000FFFFh    ;358h   ; Sprite 94  Sound 3
           dq    008F93150000FFFFh    ;360h   ; Sprite 95  Sound 4
           dq    008F93150000FFFFh    ;368h   ; Sprite 96  Sound 5
           dq    008F93150000FFFFh    ;370h   ; Sprite 97  Sound 6
           dq    008F93150000FFFFh    ;378h   ; Sprite 98  Sound 7
           dq    008F93150000FFFFh    ;380h   ; Sprite 99  Sound 8
           dq    008F93150000FFFFh    ;388h   ; Sprite 100 Sound 9
           dq    008F93150000FFFFh    ;390h   ; Sprite 101 Sound 10
           dq    008F93150000FFFFh    ;398h   ; Sprite 102 Sound 11
           dq    008F93150000FFFFh    ;3A0h   ; Sprite 103 Sound 12
           dq    008F93150000FFFFh    ;3A8h   ; Sprite 104 Sound 13
           dq    008F93150000FFFFh    ;3B0h   ; Sprite 105 Sound 14
           dq    008F93150000FFFFh    ;3B8h   ; Sprite 106 Sound 15
           dq    008F93150000FFFFh    ;3C0h   ; Sprite 107 Sound 16
           dq    008F93150000FFFFh    ;3C8h   ; Sprite 108 Kugel
           dq    008F93150000FFFFh    ;3D0h   ; Sprite 109 Space Ship 1
           dq    008F93150000FFFFh    ;3D8h   ; Sprite 110 Space Ship 2
           dq    008F93150000FFFFh    ;3E0h   ; Sprite 111 Robot 1
           dq    008F93150000FFFFh    ;3E8h   ; Sprite 112 Robot 2
           dq    008F93150000FFFFh    ;3F0h   ; Sprite 113


   GDTPtr  dw    3F8h
   Base    dd    0

 IDTPtr    dq    160                         ; Lnge der IRQ-Tab
                                             ; + lineare Addr
    IDT    dw    offset EXP,8,8600h,0        ; 00
           dw    offset EXP,8,8600h,0        ; 01
           dw    offset EXP,8,8600h,0        ; 02
           dw    offset EXP,8,8600h,0        ; 03
           dw    offset EXP,8,8600h,0        ; 04
           dw    offset EXP,8,8600h,0        ; 05
           dw    offset EXP,8,8600h,0        ; 06
           dw    offset EXP,8,8600h,0        ; 07
           dw    offset IRQ,8,8600h,0        ; 08 ;Timer
           dw    offset Key,8,8600h,0        ; 09 ;Keys
           dw    offset EXP,8,8600h,0        ; 0A
           dw    offset DMA,8,8600h,0        ; 0B ;DMA - IRQ 3
           dw    offset IRQ,8,8600h,0        ; 0C
           dw    offset DMA,8,8600h,0        ; 0D ;DMA - IRQ 5
           dw    offset IRQ,8,8600h,0        ; 0E
           dw    offset DMA,8,8600h,0        ; 0F ;DMA - IRQ 7
           dw    offset EXP,8,8600h,0        ; 10
           dw    offset IRQ,8,8600h,0        ; 11
           dw    offset IRQ,8,8600h,0        ; 12
           dw    offset IRQ,8,8600h,0        ; 13
           dw    offset IRQ,8,8600h,0        ; 14
           dw    offset IRQ,8,8600h,0        ; 15

  R_IDT    dq    0,0

 D_Name    db    'PIC.001',0    ;Backgr.
 T_Name    db    'TAB.001',0    ;Water Sin Tabs
 SPName    db    'SPRITE.001',0 ;Sprites
 S_Tab     db    'SPTAB.001',0  ;Sprite-Moving-Tabs
 Load      db    'LOAD.PIC',0   ;LOADING - Screen
 Kollision db    'KOLL.001',0   ;Kollision
 WAV       db    'TRANCE.WAV',0   ;Sound

 Handle    dw    0
 SS_Seg    dd    0

 Spr_Rt    dw    offset SpRt9 ;???
           dw    offset SpRt2 ;Small  1/2
           dw    offset SpRt5 ;Power Up            ;Sprite Routines
           dw    offset SpRt4 ;Long 1/2
           dw    offset SpRt3 ;Round
           dw    offset SpRt6 ;Sat
           dw    offset SpRt1 ;Big 1/2
           dw    offset SpRt7 ;Rocks 1-16

   Keys    db    80h dup (128)
   S_EA    db    0          ; 128        Shoot E / A
   Flame   db    0          ; 129        Flamme
   SPR0    dw    242,122,0,0; 130 / 134  Fighter
   SPR1    dw    0,0,0,1    ; 138 / 142  Shoot   x,y Koord,Treffer,Spr.Nr
   Enemy   dq    256 dup(0) ; 146 / 150..Enemys

 ;  Background           by 100000h-11F400h ( 128000 / 1F400h Bytes )
 ;  Screen in Mem.       by 120000h-141000h ( 135168 / 21000h Bytes )
 ;  Water - Tab          by 148000h-149900h ( 135168 / 21000h Bytes )
 ;  Scroll - Tab         by 11F400h-11F800h (    400 / 190h   Bytes )

 ;  Tree - Count         by 11F800h         ( 16 Bit                )
 ;  Anz der Sprites      by 11F802h         ( 8 Bit                 )
 ;  Sprite Counter       by 11F804h         ( 16 Bit  / 0 - 65535   )
 ;  Sprite Routine Var.1 by 11F806h         ( 16 Bit                )
 ;  Sprite Routine Var.2 by 11F808h         ( 16 Bit                )
 ;  Enemy Power          by 11F80Ah         ( 16 Bit                )
 ;  Sprite Routine       by 11F80Ch         ( 16 Bit                )
 ;  Lives                by 11F80Eh         ( 8  Bit  / 8   Bit     )
 ;  Station Count        by 11F810h         ( 8  Bit  / 8   Bit     )
 ;  Satellite E / A      by 11F812h         ( 16 Bit                )
 ;  Get Ready            by 11F814h         ( 16 Bit                )
 ;  Ship Explosion       by 11F816h         ( 16 Bit                )
 ;  Game Over            by 11F818h         ( 16 Bit                )
 ;  Punkte               by 11F81Ah         ( 4 * 8  Bit = 32 Bit   )
 ;  Double-Shoot * 2     by 11F820h         ( 4*4 Words = 32 Bytes  )
 ;  Sat 2                by 11F840h         ( 2 Bytes               )
 ;  Shield               by 11F844h         ( 1 Byte                )
 ;  Shield Count         by 11F845h         ( 1 Word  / 2 Bytes     )
 ;  Sound                by 11F847h         ( 1 DWord / 4 Bytes     )

 ;  Zhler 1             by 11FFFFh         ( 8  Bit  / 0 - 255     )
 ;  Zhler 2             by 11FFFDh         ( 16 Bit  / 0 - 639     )
 ;  Zhler 3             by 11FFFCh         ( 8  Bit  / 0 - 255     )
 ;  Sprites              by 150000h-  ???   ( ca. 130000 Bytes      )
 ;  Sp Dat Koll          by 1EC000h-1F0000h ( 8 Bytes / Sprite      )
 ;  Sp Tabs              by 1F0000h-200000h ( 512 Bytes / y-Sprite  )
code ends
end start
end